//
//  iPhoneCommTestAppDelegate.h
//  iPhoneCommTest
//
//  Created by nsato on 09/08/11.
//  Copyright __MyCompanyName__ 2009. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <Foundation/Foundation.h>
#import <CFNetwork/CFNetwork.h>
#import "OSCPort.h"
#import "MultipartPostHelper.h"
#import "AsyncUdpSocket.h"
#import "LRFView.h"

@class OSCPort;
@class AsyncUdpSocket;
@class MultipartPostHelper;
//@class LRFView;

@interface iPhoneCommTestAppDelegate : NSObject <UIApplicationDelegate, UITabBarControllerDelegate, UIAccelerometerDelegate> {
    UIWindow *window;
    UITabBarController *tabBarController;

	IBOutlet LRFView *myLRFView;

	
	IBOutlet id Button0;
	IBOutlet id Button1;
	IBOutlet id Button2;
	IBOutlet id Button3;
	IBOutlet id Button4;
	IBOutlet id Button5;
	IBOutlet id Button6;
	IBOutlet id Button7;
	IBOutlet id Button8;
	IBOutlet id Button9;
	IBOutlet id Slider0;
	IBOutlet id Slider1;
	IBOutlet id Switch0;
	IBOutlet id text0;
	
	IBOutlet id IpAddress;
	IBOutlet id SendPort;
	
	IBOutlet int buttonCount;
//	IBOutlet id groundAngle;
	
	float slider0Value;
	float slider1Value;
	
	int switch0Value;
	int text0Value;
	bool editFlag;

	float angle;
	float accelX;
	float accelY;
	float accelZ;
	double gpsE;
	double gpsN;
	float compass;
	int timerCounter;
	
	//timer
	NSTimer *firstTimer;
	//timer
	NSTimer *httpTimer;
	//OSC OutPort
	OSCPort *port;
	
	NSUserDefaults  *aDefault;
	int sport;
	const char* testip;
	NSString *testipSt;
	NSString *saveIpSt;
	
	AsyncUdpSocket *serverSocket;
	int testCount;	
}

-(void)openUDPToSever:(NSString *)server withPort:(NSInteger)serverport;
-(void)sendTextToServer:(NSString *)t;
-(void)processServerData:(NSString *)data;
- (BOOL)onUdpSocket:(AsyncUdpSocket *)sock didReceiveData:(NSData *)data withTag:(long)tag fromHost:(NSString *)host port:(UInt16)serverport;


- (IBAction)button0Action:(id)sender;
- (IBAction)button0NotAction:(id)sender;
- (IBAction)button1Action:(id)sender;
- (IBAction)button1NotAction:(id)sender;
- (IBAction)button2Action:(id)sender;
- (IBAction)button2NotAction:(id)sender;
- (IBAction)button3Action:(id)sender;
- (IBAction)button3NotAction:(id)sender;
- (IBAction)button4Action:(id)sender;
- (IBAction)button4NotAction:(id)sender;
- (IBAction)button5Action:(id)sender;
- (IBAction)button5NotAction:(id)sender;
- (IBAction)button6Action:(id)sender;
- (IBAction)button6NotAction:(id)sender;
- (IBAction)button7Action:(id)sender;
- (IBAction)button7NotAction:(id)sender;
- (IBAction)button8Action:(id)sender;
- (IBAction)button8NotAction:(id)sender;
- (IBAction)button9Action:(id)sender;
- (IBAction)button9NotAction:(id)sender;
- (IBAction)slider0Action:(id)sender;
- (IBAction)slider1Action:(id)sender;
- (IBAction)switch0Action:(id)sender;
- (IBAction)text0Action:(id)sender;
- (IBAction)text0BeginAction:(id)sender;
- (IBAction)text0EndAction:(id)sender;

- (IBAction)runButton:(id)sender;

- (IBAction)ipExitAction:(id)sender;
- (IBAction)portExitAction:(id)sender;
-(NSData *)getUploadTestFile;

-(void)openUDPToSever:(NSString *)server withPort:(NSInteger)port;
-(void)sendTextToServer:(NSString *)t;
-(IBAction)startConnection;

@property (nonatomic, retain) IBOutlet LRFView *myLRFView;

@property (nonatomic, retain) AsyncUdpSocket *serverSocket;
@property (nonatomic, retain) IBOutlet UIWindow *window;
@property (nonatomic, retain) IBOutlet UITabBarController *tabBarController;
@property (nonatomic, retain) NSUserDefaults *aDefault;
@property (nonatomic, retain) NSString *testipSt;
@property (nonatomic, retain) NSString *saveIpSt;
//@property (nonatomic, retain) int timerCounter;


@end
