//
//  iPhoneCommTestAppDelegate.m
//  iPhoneCommTest
//
//  Created by nsato on 09/08/11.
//  Copyright __MyCompanyName__ 2009. All rights reserved.
//

#import "iPhoneCommTestAppDelegate.h"

#define D_O_PORT 57110

@implementation iPhoneCommTestAppDelegate

@synthesize window;
@synthesize tabBarController;
@synthesize aDefault;
@synthesize testipSt;
@synthesize saveIpSt;
//@synthesize timerCounter;
@synthesize serverSocket;
@synthesize myLRFView;


- (IBAction)button0Action:(id)sender{
	buttonCount+=1;
	[port sendTo:"count" types:"i", buttonCount];
//	NSLog(@"button0: %d",buttonCount);

}
- (IBAction)button0NotAction:(id)sender{
	buttonCount-=1;
	[port sendTo:"count" types:"i", buttonCount];
}
- (IBAction)button1Action:(id)sender{
	buttonCount+=2;
	[port sendTo:"count" types:"i", buttonCount];
}
- (IBAction)button1NotAction:(id)sender{
	buttonCount-=2;
	[port sendTo:"count" types:"i", buttonCount];
}
- (IBAction)button2Action:(id)sender{
	buttonCount+=4;
	[port sendTo:"count" types:"i", buttonCount];
}
- (IBAction)button2NotAction:(id)sender{
	buttonCount-=4;
	[port sendTo:"count" types:"i", buttonCount];
}
- (IBAction)button3Action:(id)sender{
	buttonCount+=8;
	[port sendTo:"count" types:"i", buttonCount];
}
- (IBAction)button3NotAction:(id)sender{
	buttonCount-=8;
	[port sendTo:"count" types:"i", buttonCount];
}
- (IBAction)button4Action:(id)sender{
	buttonCount+=16;
	[port sendTo:"count" types:"i", buttonCount];
}
- (IBAction)button4NotAction:(id)sender{
	buttonCount-=16;
	[port sendTo:"count" types:"i", buttonCount];
}
- (IBAction)button5Action:(id)sender{
	buttonCount+=32;
	[port sendTo:"count" types:"i", buttonCount];
}
- (IBAction)button5NotAction:(id)sender{
	buttonCount-=32;
	[port sendTo:"count" types:"i", buttonCount];
}
- (IBAction)button6Action:(id)sender{
	buttonCount+=64;
	[port sendTo:"count" types:"i", buttonCount];
}
- (IBAction)button6NotAction:(id)sender{
	buttonCount-=64;
	[port sendTo:"count" types:"i", buttonCount];
}
- (IBAction)button7Action:(id)sender{
	buttonCount+=128;
	[port sendTo:"count" types:"i", buttonCount];
}
- (IBAction)button7NotAction:(id)sender{
	buttonCount-=128;
	[port sendTo:"count" types:"i", buttonCount];
}
- (IBAction)button8Action:(id)sender{
	buttonCount+=256;
	[port sendTo:"count" types:"i", buttonCount];
}
- (IBAction)button8NotAction:(id)sender{
	buttonCount-=256;
	[port sendTo:"count" types:"i", buttonCount];
}
- (IBAction)button9Action:(id)sender{
	buttonCount+=512;
	[port sendTo:"count" types:"i", buttonCount];
}
- (IBAction)button9NotAction:(id)sender{
	buttonCount-=512;
	[port sendTo:"count" types:"i", buttonCount];
}
- (IBAction)slider0Action:(id)sender{
//	slider0Value = [(UISlider *)Slider0 value];
//	[port sendTo:"slid0" types:"i", (int)(slider0Value*100.0)];
}
- (IBAction)slider1Action:(id)sender{
//	slider1Value = [(UISlider *)Slider1 value];
//	[port sendTo:"slid1" types:"i", (int)(slider1Value*100.0)];
}
- (IBAction)switch0Action:(id)sender{
	//	slider1Value = [(UISlider *)Slider1 value];
	//	[port sendTo:"slid1" types:"i", (int)(slider1Value*100.0)];
}
- (IBAction)text0Action:(id)sender{
}

- (IBAction)text0BeginAction:(id)sender{
	editFlag=true;
}
- (IBAction)text0EndAction:(id)sender{
	editFlag=false;
}

- (IBAction)ipExitAction:(id)sender{
	[aDefault setObject:[IpAddress text] forKey:@"pcip"];
	[aDefault synchronize];
}

- (IBAction)portExitAction:(id)sender{
	[aDefault setInteger:[[SendPort text] intValue] forKey:@"sport"];	
	[aDefault synchronize];
}

- (void)applicationDidFinishLaunching:(UIApplication *)application {
	//initarize
	buttonCount = 0;
	editFlag=false;
	testCount=0;

	[[UIAccelerometer sharedAccelerometer] setDelegate:self];
	
	if(firstTimer ==nil){
		//timer start
		timerCounter=0;
		firstTimer = [NSTimer scheduledTimerWithTimeInterval:1/2.0
													  target:self selector:@selector(timerMethod:)
													userInfo:nil
													 repeats:YES];
	}else{
		//timer stop
		[firstTimer invalidate];
		firstTimer = nil;
	}
	if(httpTimer ==nil){
		//timer start
		httpTimer = [NSTimer scheduledTimerWithTimeInterval:1/5.0
													  target:self selector:@selector(httpTimerMethod:)
													userInfo:nil
													 repeats:YES];
	}else{
		//timer stop
		[httpTimer invalidate];
		httpTimer = nil;
	}
	
    // Add the tab bar controller's current view as a subview of the window
	[window addSubview:tabBarController.view];
	[window makeKeyAndVisible];

}

-(void)awakeFromNib{
	
	
//	aDefault=[NSUserDefaults standardUserDefaults];
	
//	int ipAddress1=[aDefault integerForKey:@"ip1"];
//	int ipAddress2=[aDefault integerForKey:@"ip2"];
//	int ipAddress3=[aDefault integerForKey:@"ip3"];
//	int ipAddress4=[aDefault integerForKey:@"ip4"];
//	int sport=[aDefault integerForKey:@"port"];
	
	aDefault = [NSUserDefaults standardUserDefaults];
	sport = [aDefault integerForKey:@"sport"];
	if(sport==0){
		sport=57110;
	}
	testipSt = [aDefault stringForKey:@"pcip"];
	if(testipSt != nil){
		testip = [testipSt UTF8String];
	}else{
		testip="192.168.11.2";
		testipSt=@"192.168.11.2";
	}
	
	port = [[OSCPort oscPortToAddress:testip portNumber:sport] retain];	
	[port loadSynthDef:"synthdefs/sine.scsyndef"];
	[port newSynthFromDef:"sine" synthID:1 parentGroup:0];
	
	//[IpAddress setText:[NSString stringWithFormat:@"%s", testip]];
	[IpAddress setText:testipSt];
	[SendPort setText:[NSString stringWithFormat:@"%d", sport]];

	serverSocket = [[AsyncUdpSocket alloc] initWithDelegate:self];
	if([serverSocket bindToPort:12340 error:nil]){
		NSLog(@"bind ok.");
	}else{
		NSLog(@"bind NG.");
	}
	
//	if([serverSocket joinMulticastGroup:@"CHANNEL_GROUP" error:nil]){
//		NSLog(@"join ok.");
//	}else{
//		NSLog(@"join NG.");
//	}
	[serverSocket receiveWithTimeout:-1 tag:1];
	[serverSocket setRunLoopModes:[NSArray arrayWithObject:NSRunLoopCommonModes]];
	
//	[self startConnection];
	
	myLRFView.wayPointArray = [[NSMutableArray alloc] init];
}


- (IBAction)runButton:(id)sender{
	NSLog([NSString stringWithFormat:@"run"]);
	NSString *sendSt=[NSString stringWithFormat:@""];
	for(int i=0;i<[myLRFView.wayPointArray count];i++){
		CGPoint currentPoint = [[myLRFView.wayPointArray objectAtIndex:i] CGPointValue];
//		NSLog([NSString stringWithFormat:@"point: %f, %f",(float)currentPoint.x,(float)currentPoint.y]);

		NSString *addSt=[NSString stringWithFormat:@"%d,%d",
						 -(int)(currentPoint.y-150)*40,
						 (int)(currentPoint.x-150)*40];
		sendSt=[NSString stringWithFormat:@"%@,%@",sendSt, addSt];
	}
	sendSt=[NSString stringWithFormat:@"%@,",sendSt];
	NSLog([NSString stringWithFormat:@"SendSt1:%@",sendSt]);
//	sendSt=[sendSt stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding];
//	NSLog([NSString stringWithFormat:@"SendSt2:%@",sendSt]);
	const char* sendChar;
	sendChar=[sendSt UTF8String];
	
	[port sendTo:"runWP" types:"s", sendChar];
	
	myLRFView.wayPointArray = [[NSMutableArray alloc] init];

	
}


//Public Action to begin connection
-(IBAction)startConnection{
    NSString *theServer=@"192.168.1.3";
    NSInteger thePort=12341;
    [self openUDPToSever:theServer withPort:thePort];
}

//Begin connection cadance
-(void)openUDPToSever:(NSString *)server withPort:(NSInteger)serverport{	   
    NSError *error = nil;
    if ([serverSocket connectToHost:server onPort:serverport error:&error]){
        [self sendTextToServer:@"FIRST COMMAND"];
    } else {
        NSLog(@"Error connecting to Server: %@", error);
    }
}

//method to send text to server
-(void)sendTextToServer:(NSString *)t{
    [serverSocket sendData:[t dataUsingEncoding:NSASCIIStringEncoding] withTimeout:-1 tag:0];
    NSLog (@"Server Out: %@",t);
}

-(void)processServerData:(NSString *)data{	
    //Process the data sent by the server 
    //and send follow-up commands if needed
}

//Called when state is received
- (BOOL)onUdpSocket:(AsyncUdpSocket *)sock didReceiveData:(NSData *)data withTag:(long)tag fromHost:(NSString *)host port:(UInt16)serverport{
    [sock receiveWithTimeout:-1 tag:0];
    NSString *e = [[NSString alloc] initWithData:data encoding:NSASCIIStringEncoding];
//	NSLog(e);
    [self processServerData:e];

//	LRFView.lrfDistanceSt=e;
//	[[[[[self tabBarController] viewControllers] objectAtIndex:3] objectAtIndex:1] objectAtIndex:1].lrfDistanceSt=[NSString stringWithFormat:@"aaa"];
//	[[[[[[self tabBarController] viewControllers] objectAtIndex:3] objectAtIndex:1] objectAtIndex:1] stTest:e];
//	myLRFView.lrfDistanceSt=[NSString stringWithFormat:@"aa"];
	self.myLRFView.lrfDistanceSt=e;
	
    [e release];
    return YES;
}
- (IBAction)repaintButton:(id)sender{
	
}



//- (IBAction)searchForSite:(id)sender
//{
//	
//	readStream=NULL;
//	writeStream=NULL;
//	iStream=nil;
//	oStream=nil;
//	
//	NSLog(@"touch down!");
//    NSString *urlStr = @"192.168.1.3";
////    if (![urlStr isEqualToString:@""]) {
//        NSURL *website = [NSURL URLWithString:urlStr];
//        if (!website) {
//            NSLog(@"%@ is not a valid URL");
//            return;
//        }
//		
//        CFStreamCreatePairWithSocketToHost(NULL, (CFStringRef)[website host], 12340, &readStream, &writeStream);
//		
//    if (readStream && writeStream) {
//        CFReadStreamSetProperty(readStream, 
//                                kCFStreamPropertyShouldCloseNativeSocket, 
//                                kCFBooleanTrue);
//        CFWriteStreamSetProperty(writeStream, 
//								 kCFStreamPropertyShouldCloseNativeSocket, 
//								 kCFBooleanTrue);
//        
//        iStream = (NSInputStream *)readStream;
//        [iStream retain];
//        [iStream setDelegate:self];
//        [iStream scheduleInRunLoop:[NSRunLoop currentRunLoop] 
//						   forMode:NSDefaultRunLoopMode];
//        [iStream open];
//        
//        oStream = (NSOutputStream *)writeStream;
//        [oStream retain];
//        [oStream setDelegate:self];
//        [oStream scheduleInRunLoop:[NSRunLoop currentRunLoop] 
//						   forMode:NSDefaultRunLoopMode];
//        [oStream open];         
//    }
//
//}
//
//- (void)stream:(NSStream *)stream handleEvent:(NSStreamEvent)eventCode {
//	
//    switch(eventCode) {
//        case NSStreamEventHasBytesAvailable:
//        {
//            if(!_data) {
//                _data = [[NSMutableData data] retain];
//            }
//            uint8_t buf[1024];
//            unsigned int len = 0;
//            len = [(NSInputStream *)stream read:buf maxLength:1024];
//			NSLog([NSString stringWithFormat:@"len:%d",len]);
//            if(len) {
//                [_data appendBytes:(const void *)buf length:len];
//                // bytesRead is an instance variable of type NSNumber.
//				int testInt=[bytesRead intValue];
//				NSLog([NSString stringWithFormat:@"data:%d",testInt]);
////                [bytesRead setIntValue:[bytesRead intValue]+len];
//            } else {
//                NSLog(@"no buffer!");
//            }
//            break;
//        }
//	}
//	switch(eventCode) {
//        case NSStreamEventEndEncountered:
//        {
//            [stream close];
//            [stream removeFromRunLoop:[NSRunLoop currentRunLoop]
//							  forMode:NSDefaultRunLoopMode];
//            [stream release];
//            stream = nil; // stream is ivar, so reinit it
//            break;
//        }
//	}
//}

//void GetTest(void *context. int arglen, const void *args, OSCTimeTag when, NetworkReturnAddressPtr returnAddr){
//	[context 
//}
//		
//send		

/*
// Optional UITabBarControllerDelegate method
- (void)tabBarController:(UITabBarController *)tabBarController didSelectViewController:(UIViewController *)viewController {
}
*/

/*
// Optional UITabBarControllerDelegate method
- (void)tabBarController:(UITabBarController *)tabBarController didEndCustomizingViewControllers:(NSArray *)viewControllers changed:(BOOL)changed {
}
*/


- (void)dealloc {
	[port release];
    [tabBarController release];
//	[regionController release];
    [window release];
    [super dealloc];
}

-(void)timerMethod:(NSTimer *)thetimer{
	//timer method
	if(firstTimer){
		
		[myLRFView setNeedsDisplay];

		
		//accel sensor
//		int sendAngle = (int)(angle*180.0f/3.14159264);
//		[port sendTo:"angle" types:"i",sendAngle];
		[port sendTo:"anglX" types:"i",(int)(accelX*180.0f/3.14159264)];
		[port sendTo:"anglY" types:"i",(int)(accelY*180.0f/3.14159264)];
		[port sendTo:"anglZ" types:"i",(int)(accelZ*180.0f/3.14159264)];
//		[groundAngle setText:[NSString stringWithFormat:@"%d", sendAngle]];
		
		//timerCounter
		timerCounter++;
		[port sendTo:"timer" types:"i",timerCounter];
//		NSLog(@"timer: %d",timerCounter);
		
		
		//slider bar
//		slider0Value = [(UISlider *)Slider0 value];
//		[port sendTo:"slid0" types:"i", (int)(slider0Value*100.0)];
//		slider1Value = [(UISlider *)Slider1 value];
//		[port sendTo:"slid1" types:"i", (int)(slider1Value*100.0)];
		
		//switch
//		if([Switch0 isOn] ==true)	switch0Value=1;
//		else	switch0Value=0;
//		[port sendTo:"swit0" types:"i", switch0Value];
		
		//textField
//		if(editFlag==false){
//			text0Value=[[text0 text] intValue];
//			[port sendTo:"text0" types:"i", text0Value];
//		}
	}
}
-(NSData *)getUploadTestFile
{
	//	NSString *dataPath = [[NSBundle mainBundle] pathForResource:@"hoge" ofType:@"png"];
	NSString *filePath = [NSString stringWithFormat:@"%@%@" ,NSHomeDirectory() , @"/Documents/test.txt"];
	NSFileManager *fm = [NSFileManager defaultManager];
	NSData *data;
	//	if([fm fileExistsAtPath:dataPath])
	if([fm fileExistsAtPath:filePath])
	{
		//		NSFileHandle *handle = [NSFileHandle fileHandleForReadingAtPath:dataPath];
		NSFileHandle *handle = [NSFileHandle fileHandleForReadingAtPath:filePath];
		data = [handle readDataToEndOfFile];
		[handle closeFile];
	}
	return data;
}

-(void)httpTimerMethod:(NSTimer *)thetimer{
	//timer method
	if(httpTimer){
		if([Switch0 isOn] ==true){
			NSLog(@"switch is on.");
			
			//送信データ作成
			NSData* data;
			NSString* test=[NSString stringWithFormat:@"%d\n%d\n%d\n%d", 
							buttonCount,
							(int)(accelX*180.0f/3.14159264), 
							(int)(accelY*180.0f/3.14159264), 
							(int)(accelZ*180.0f/3.14159264)
							];
			data=[test dataUsingEncoding:NSUTF8StringEncoding];
			
			// アップロード先URL
			NSString* urlStr = @"http://www.satolab.org/temp/upload.php";
			//---------------------------->> 文字列データの作成
			NSArray* stringKeys = [[NSArray alloc] initWithObjects:@"upload", @"dummy",nil];
			NSArray* stringValues = [[NSArray alloc] initWithObjects:@"test", @"dum", nil];	
			NSDictionary* stringDict = [[NSDictionary alloc] initWithObjects:stringValues forKeys:stringKeys];
			
			//---------------------------->> バイナリデータの作成
			NSArray* binaryKeys = [[NSArray alloc] initWithObjects:@"data", @"orgName", @"postName", nil];
			NSArray* binaryValues = [[NSArray alloc] initWithObjects:data, @"dum", @"txtFile", nil];
			NSDictionary* binaryDict = [[NSDictionary alloc] initWithObjects:binaryValues forKeys:binaryKeys];	
			NSArray* binaries = [[NSArray alloc] initWithObjects:binaryDict, nil];
			MultipartPostHelper* postHelper = [[MultipartPostHelper alloc] init:urlStr];
			// バイナリデータの追加
			[postHelper setBinaryValues:binaries];
			// 文字データの追加
			[postHelper setStringValues:stringDict];
			
			// 送信処理
//			NSString* res = [postHelper send];
			[postHelper send];
			// 送信先から返されるデータをNSLogで表示
			//NSLog(res);
			
			[postHelper dealloc];
			
			testCount++;
			
		}
	}
}
- (void)accelerometer: (UIAccelerometer *)accelerometer
		didAccelerate: (UIAcceleration *)acceleration
{
	float xx = -[acceleration x];
	float yy = [acceleration y];
	float zz = [acceleration z];
	accelX=xx;
	accelY=yy;
	accelZ=zz;
//	angle = atan2(yy, xx)+3.14f/2.0f;
//	int sendAngle = (int)(angle*180.0f/3.14159264);
}

//- (NSString *) localIPAddress{
//	char baseHostName[255];
//	gethostname(baseHostName, 255);
//	
//	char hn[255];
//	sprintf(hn, "%s.local", baseHostName);
//	struct hostent *host = gethostbyname(hn);
//	if(host == NULL){
//		herror("resolv");
//		return NULL;
//	}else{
//		struct in_addr **list = host->h_addr_list;
//		return [NSString stringWithCString:inet_neta(*list[0])];
//	}
//	retrun NULL;
//	
//}


@end

